.code

MOVE_FORWARD MACRO adr, len
	local ok1_label, end_label, modulo_label, end_modulo_label
	
	IFDIFI <adr>, <eax>
		push eax
		mov eax, adr
	ENDIF
	IFDIFI <adr> , <ebx>
		push ebx
	ENDIF
	IFDIFI <len>, <ebx>
		mov ebx, len
	ENDIF
	
modulo_label:
	cmp ebx, buffer_length
	jbe end_modulo_label
	sub ebx, buffer_length
	jmp modulo_label
end_modulo_label:

	add eax, ebx
	jnc ok1_label
	mov error_text, offset text_internal_error
	jmp global_error
ok1_label:
	cmp eax, buffer_end_ptr
	jb end_label
	;eax points behind buffer
	sub eax, buffer_end_ptr
	add eax, buffer_start_ptr
end_label:
	mov adr, eax
	
	IFDIFI <adr>, <ebx>
		pop ebx
	ENDIF
	IFDIFI <adr>, <eax>
		pop eax
	ENDIF
ENDM
; ********************************************************************

MOVE_BACKWARD MACRO adr, len
	local ok1_label, end_label, modulo_label, end_modulo_label
	
	IFDIFI <adr>, <eax>
		push eax
		mov eax, adr
	ENDIF
	IFDIFI <adr>, <ebx>
		push ebx
	ENDIF
	IFDIFI <len>, <ebx>
		mov ebx, len
	ENDIF
	
modulo_label:
	cmp ebx, buffer_length
	jbe end_modulo_label
	sub ebx, buffer_length
	jmp modulo_label
end_modulo_label:

	sub eax, ebx
	jnc ok1_label
	mov error_text, offset text_internal_error
	jmp global_error
ok1_label:
	cmp eax, buffer_start_ptr
	jnb end_label
	;eax points before buffer
	mov ebx, buffer_start_ptr
	sub ebx, eax
	mov eax, buffer_end_ptr
	sub eax, ebx
end_label:
	mov adr, eax
	
	IFDIFI <adr>, <ebx>
		pop ebx
	ENDIF
	IFDIFI <adr>, <eax>
		pop eax
	ENDIF
ENDM
; *****************************************************************

